'use strict';

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _autoprefixerCore = require('autoprefixer-core');

var _autoprefixerCore2 = _interopRequireDefault(_autoprefixerCore);

var _cleanCss = require('clean-css');

var _cleanCss2 = _interopRequireDefault(_cleanCss);

var _foreach = require('foreach');

var _foreach2 = _interopRequireDefault(_foreach);

var _transformSpecificationIntoCSS = require('./transformSpecificationIntoCSS');

var _transformSpecificationIntoCSS2 = _interopRequireDefault(_transformSpecificationIntoCSS);

exports['default'] = function (stylesheets, options) {
  var css = '';

  _foreach2['default'](stylesheets, function (stylesheet, name) {
    var cssOptions = _Object$assign({}, options);
    cssOptions.prefixes = [options.filename, name];

    css += _transformSpecificationIntoCSS2['default'](stylesheet, cssOptions);

    if (css.length) {
      css += '\n';
    }
  });

  if (css.length === 0) {
    return null;
  }

  var vp = options.vendorPrefixes;

  if (vp) {
    if (typeof vp === 'object') {
      css = _postcss2['default']([_autoprefixerCore2['default'](vp)]).process(css).css;
    } else {
      css = _postcss2['default']([_autoprefixerCore2['default']]).process(css).css;
    }
  }

  if (options.minify) {
    css = new _cleanCss2['default']().minify(css).styles;
  }

  return css;
};

module.exports = exports['default'];
